/**
 * Plugin Adm_redacteurs
 * Version  : 5.5.4 (2008/12/30)
 * Compatibility : Guppy v4.6.6+
 * Author   : jrme CROUX (djchouix)
 * Web site : http://lebrikabrak.info/
 * E-mail   : lebrikabrak@free.fr
 * Licence  : GNU Lesser General Public License
 *
 * Ce fichier est bas sur :
 *
 * Plugin FCKeditor
 * Version  : 4.6.4.2.6.3 (2008/12/23)
 * Compatibility : Guppy v4.6.x
 * Author   : jrme CROUX (djchouix)
 * Web site : http://lebrikabrak.info/
 * E-mail   : lebrikabrak@free.fr
 * Licence  : GNU Lesser General Public License
 */

/**
 * parseSmiley
 * analyse et convertit les symboles des smileys en code HTML (pas ncessaire avec Minieditor)
 * @param content  string le code  analyser
 * @param basePath string  l'url du site
 **/
function parseSmiley(content)
{
	var code = content;
	var motif = ['\\|:-\\)', ';-\\)', ':-\\)\\)', ':-\\)', ':-o', ':o\\)', ':-\\(\\(', ':-\\(', '8-\\)', ':-p', ';-\\('];
	var smiley = ['cool', 'wink', 'biggrin', 'smile', 'frown', 'eek', 'mad', 'confused', 'rolleyes', 'tongue', 'cry'];
	for (i = 0; i < motif.length; i++) {
		var expreg = new RegExp(motif[i], 'g');
		var img = '<img src="inc/img/smileys/' + smiley[i] + '.gif" alt="' + smiley[i] + '" border="0" />';
		code = code.replace(expreg, img);		
	}
	return code;
};

/**
 * parseFlash
 * analyse et convertit le code qui correspond aux fichiers flash (compatibilit FCKEditor <--> Minieditor)
 * @param content  string le code  analyser
 * @param basePath string  l'url du site
 **/
function parseFlash(content)
{
	var code = content.replace(/<object data=("[-a-z0-9_:\/\.]+") (width="[0-9]+") (height="[0-9]+")( hspace="[0-9]+")?( vspace="[0-9]+")?( align="[a-z]+")?( id="[-a-z0-9_]+")?( class="[-a-z0-9_]+")? type="application\/x-shockwave-flash"><param name="movie" value="[-a-z0-9_:\/\.]+" \/>(<param name="(quality)" value(="[-a-z0-9_]+") \/>)?(<param name="(scale)" value(="[-a-z0-9_]+") \/>)?(<param name="(loop)" value(="[a-z]+") \/>)?(<param name="(play)" value(="[a-z]+") \/>)?(<param name="(menu)" value(="[a-z]+") \/>)?(<param name="(bgcolor)" value(="[#0-9ABCDEF]+") \/>)?<param name="pluginurl" value="http:\/\/www\.macromedia\.com\/go\/getflashplayer" \/><a href="http:\/\/www\.macromedia\.com\/go\/getflashplayer" target="_blank"><img src="[-a-z0-9_:\/\.]+" alt="Get FlashPlayer" title="Get FlashPlayer" width="[0-9]+" height="[0-9]+" border="0" \/><\/a><\/object>/gi,'<embed src=$1 $2 $3 $4 $5 $6 $7 $8 $10$11 $13$14 $16$17 $19$20 $22$23 $25$26 type="application\/x-shockwave-flash" pluginspage="http:\/\/www.macromedia.com\/go\/getflashplayer"><\/embed>');
	return code;
};

/**
 * recupContent
 * rcupre le code qui sera affich dans l'diteur
 * @param nameform     string le nom du formulaire contenant le code rcupr (attribut name de <form>)
 * @param nametextarea string le nom du textarea contenant le code rcupr (attribut name de <textarea>)
 **/
function recupContent(nameform, nametextarea)
{
	if(window.opener.document.forms[nameform].elements[nametextarea]) {
		var content = window.opener.document.forms[nameform].elements[nametextarea].value;
	} else {
		var content = '';
		alert('Error : The opener document is not defined.');
	}
	return content;
};

/**
 * parseContent
 * analyse le code qui sera affich dans l'diteur
 * @param content     string  le code  analyser
 * @param basePath    string  l'url du site
 * @param dirUpload   string  l'ensemble des rpertoires autoriss pour l'upload
 * @param minieditor  boolean Existence ou non du minieditor
 **/
function parseContent(content, minieditor)
{
	var code = content;
	if (!minieditor) { code = parseSmiley(code); }
	if (minieditor) { code = parseFlash(code); }
	return code;
};

/**
 * initDocument
 * rcupre et analyse le code qui sera affich dans l'diteur
 * @param nameform     string le nom du formulaire contenant le code rcupr (attribut name de <form>)
 * @param nametextarea string le nom du textarea contenant le code rcupr (attribut name de <textarea>)
 * @param basePath     string l'url du site
 * @param pathEditor   string le chemin relatif du rpertoire contenant le fichier editorFCK.php
 * @param pathUpload   string le chemin relatif du rpertoire contenant le rpertoire upload/
 **/
function initDocument(nameform, nametextarea, minieditor)
{	
	var content = recupContent(nameform, nametextarea); //Rcupration du code
	content = parseContent(content, minieditor); //Analyse du code			
	return content;
};

/**
 * createFCKEditor
 * cre et affiche l'diteur
 * @param name       string le nom de l'diteur
 * @param width      string/number la largeur de l'diteur (px ou %)
 * @param height     string/number la hauteur de l'diteur (px ou %)
 * @param content    string le contenu de la zne d'dition de l'diteur
 * @param lang       string la langue de l'diteur
 * @param basePath   string l'url du site
 * @param pathEditor string le chemin relatif du rpertoire contenant le fichier editorFCK.php
 * @param pathUpload string le chemin relatif du rpertoire contenant le rpertoire upload/
**/
function createFCKEditor(name, width, height, content, lang, basePath, pathEditor, pathUpload)
{
	oFCKeditor = new FCKeditor(name);
	
    oFCKeditor.Value = content;
	oFCKeditor.Width = width;
	oFCKeditor.Height = height;
    oFCKeditor.BasePath = basePath + 'inc/fckeditor/';  //chemin de l'diteur
	oFCKeditor.Config["BaseHref"] = basePath;
	oFCKeditor.Config["AutoDetectLanguage"] = (lang == null)? true : false;
	oFCKeditor.Config["DefaultLanguage"]    = (lang == null)? 'en' : lang;
	oFCKeditor.Config["CustomConfigurationsPath"] = basePath + pathEditor + 'fckeditor_config/guppy_fckconfig.js';  //configuration de l'diteur
	oFCKeditor.Config["EditorAreaCSS"] = basePath + pathEditor + 'fckeditor_config/custom/guppy_fckeditorarea.css';  //customisation du style du textarea de l'diteur
	oFCKeditor.Config["SkinPath"] = basePath + pathEditor + 'fckeditor_config/custom/skin_guppy/';  //customisation du skin des barres outils
	oFCKeditor.Config["StylesXmlPath"] = basePath + pathEditor + 'fckeditor_config/custom/guppy_fckstyles.xml'; //customisation du menu droulant Styles dans l'diteur (voir fichier guppy_fckstyles.xml et guppy_fckeditorarea.css)
	oFCKeditor.Config["TemplatesXmlPath"] = basePath + pathEditor + 'fckeditor_config/custom/guppy_fcktemplates.xml'; //customisation des Modles (templates) accessibles via l'icone dans le menu de l'diteur (voir fichier guppy_fcktemplates.xml)
	oFCKeditor.ToolbarSet = "Guppy" ;  //barres outils customises (voir fichier guppy_fckconfig.js)
    oFCKeditor.Config["ImageBrowserURL"] = basePath + pathUpload + 'upload/upload.php?lng=' + lang + '&uptype=Image&namerepconfig=fckeditor_config&pathconfig=' + pathEditor; //rcupration du rpertoire img et photo de guppy
    oFCKeditor.Config["LinkBrowserURL"] = basePath + pathUpload + 'upload/upload.php?lng=' + lang + '&uptype=Link&namerepconfig=fckeditor_config&pathconfig=' + pathEditor ; //rcupration du rpertoire file, img, photo, pages et flash de guppy
    oFCKeditor.Config["FlashBrowserURL"] = basePath + pathUpload + 'upload/upload.php?lng=' + lang + '&uptype=Flash&namerepconfig=fckeditor_config&pathconfig=' + pathEditor; //rcupration du rpertoire flash de guppy	
	oFCKeditor.Config["SmileyWindowWidth"]	= 300 ;
	oFCKeditor.Config["SmileyWindowHeight"]	= 300 ;

	oFCKeditor.Create() ;
};

/**
 * insertSmiley
 * Insre un smiley Guppy dans l'diteur lors du click
 * @param instanceName    string le nom attribu  l'diteur lors de sa cration
 * @param src    string l'url de l'image
 * @param alt    string l'attribut alt de l'image
 * @param width  number la largeur de l'image (px)
 * @param height number la hauteur de l'image (px)
 **/
function insertSmiley(instanceName, src, alt, width, height)
{
	var oEditor = FCKeditorAPI.GetInstance(instanceName);
	
	if (oEditor.EditMode == FCK_EDITMODE_WYSIWYG) {
		oImg = oEditor.CreateElement( 'IMG' );
		oImg.src = src ;
		oImg.setAttribute('_fcksavedurl', src) ;
		oImg.alt = alt;
		oImg.title = alt;
		oImg.width = width;
		oImg.height = height;
		oImg.border = 0;
	} else {
		return false;
	}
};

/**
 * initEditor
 * initialise l'diteur en lui ajoutant des fonctionnalits
 **/
function initEditor()
{
	resizeEditor();
	addEventSmileysEditor();
	
	/* Fix for Safari 3.0.3 */
	/*var nav = navigator.userAgent.indexOf("Safari");
	if (nav != -1) {
		var version = navigator.userAgent.substr(navigator.userAgent.indexOf("WebKit/") + 7, 3);
		if (parseInt(version) == 522) {
			addEventSaveEditor();
		}
	}*/
	/* End Fix for Safari 3.0.3 */
};

/**
 * resizeEditor
 * redimensionne la hauteur de l'diteur dans la fentre active
 **/
function resizeEditor()
{
	var size = getSizeWindow();	
	var sizeBlock = getSizeBlock("smileysGuppy");
	var height = size[1] - sizeBlock[1];

	if (document.getElementById("editor___Frame")) {
		var iframe = document.getElementById("editor___Frame");
		iframe.style.height =  height + "px";
	} else {
		return false;
	}
};

/**
 * getSizeWindow
 * rcupre la taille (largeur et hauteur) de la fentre active
 * @return array  array(width, height)
 **/
function getSizeWindow()
{
	// Width & Height of window
	var size = new Array();
	if (window.innerHeight) {// all except Explorer
	  size[0] = window.innerWidth;
	  size[1] = window.innerHeight;
	} else if (document.documentElement && document.documentElement.clientHeight) { // Explorer 6 Strict Mode
	  size[0] = document.documentElement.clientWidth;
	  size[1] = document.documentElement.clientHeight;
	} else if (document.body) { // other Explorers
	  size[0] = document.body.clientWidth;
	  size[1] = document.body.clientHeight;
	}
	
	return size;
};

/**
 * getSizeBlock
 * rcupre la taille (largeur et hauteur) d'un block
 * @return array  array(width, height)
 **/
function getSizeBlock(id)
{
	// Width & Height of block
	var size = new Array();
	if (document.getElementById(id)) {
		size[0] = document.getElementById(id).offsetWidth;
		size[1] = document.getElementById(id).offsetHeight;
	}
	
	return size;	
};

/**
 * addEventSmileys
 * ajoute l'venement qui permet de dsactiver ou non les smileys Guppy selon l'tat de l'diteur
 **/
function addEventSmileysEditor()
{
	if (document.getElementById("editor___Frame")) {
		var iframe = document.getElementById("editor___Frame");
		var toolbar = iframe.contentWindow.document.getElementById("xToolbar");
		addListener(toolbar, 'click', disabledSmileys);
	} else {
		return false;
	}
};

/**
 * disabledSmileys
 * dsactive ou non les smileys Guppy selon l'tat de l'diteur
 **/
function disabledSmileys()
{
	var smileys = document.getElementById("smileysGuppy");
	var oEditor = FCKeditorAPI.GetInstance("editor");

	if (oEditor.EditMode == FCK_EDITMODE_WYSIWYG) {
		smileys.className = "smileysGuppy";
	} else {
		smileys.className = "smileysGuppy_disabled";
	}
};

/**
 * addListener
 * ajoute un gestionnaire d'vnement  un lment
 **/
function addListener(element, baseName, handler)
{
	if (element.addEventListener) {
		element.addEventListener(baseName, handler, false);
	} else if (element.attachEvent) {
		element.attachEvent('on' + baseName, handler);
	}
};


/**
 * addEventSaveEditor
 * ajoute un gestionnaire d'vnement au bouton Enregistrer ( ncessaire pour corriger un bug avec Safari 3.0.3)
 **/
/*function addEventSaveEditor()
{
	if (document.getElementById("editor___Frame")) {
		var iframe = document.getElementById("editor___Frame");
		var toolbar = iframe.contentWindow.document.getElementById("xToolbar");
		var buttons = toolbar.getElementsByTagName("img");
		
		for (var i = 0; i < buttons.length; i++) {
			if (buttons.item(i).style.backgroundPosition == "0px -32px") {
				var button_save = buttons.item(i).parentNode;
			}
		}	
		addListener(button_save, 'mousedown', submitContentEditor);
	} else {
		return false;
	}
};*/

/**
 * submitContentEditor
 * soumission du formulaire suite au click du bouton Enregistrer ( ncessaire pour corriger un bug avec Safari 3.0.3)
 **/
/*function submitContentEditor()
{
	var form = document.getElementById("fHtmlEditor");
	var content = document.getElementById("editor");
	var oEditor = FCKeditorAPI.GetInstance("editor");
	content.value = oEditor.EditorDocument.body.innerHTML;
	form.submit();
};
*/